<?php

namespace Modules\Db\Http\Controllers;

use Modules\Pp\Entities\CustomerOrder;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;


class CustomerOrderListController extends Controller
{
    public function allCustomerOrder($year, $month)
    {
        try {

            $query = 'SELECT *FROM pp_customer_orders';


            if ($year == 0 && $month == 0) {
            } else if ($year != 0 && $month == 0) {
                $date = $year . "%";
                $query .= ' WHERE pp_customer_orders.date LIKE "' . $date . '" ';
            } else if ($year == 0 && $month != 0) {
                if (strlen($month) == 1) {
                    $date = "0" . $month . "%";
                } else {
                    $date =  $month . "%";
                }
                $query .= ' WHERE MONTH(pp_customer_orders.date) = "' . $date . '" ';
            } else {
                if (strlen($month) == 1) {
                    $date = $year . "-0" . $month . "%";
                } else {
                    $date = $year . "-" . $month . "%";
                }
                $query .= ' WHERE pp_customer_orders.date LIKE "' . $date . '" ';
            }

            $result = DB::select($query);
            $responseBody = $this->responseBody(true, "CustomerOrderListController", "allCustomerOrder", $result);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "allCustomerOrder", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }








    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
