<?php

namespace Modules\Db\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;

class DashboardController extends Controller
{

    public function count($year, $month)
    {
        $date = $year . "-" . $month . "%";

        $usa_today = 0;
        $usa_month = 0;
        $local_today = 0;
        $local_month = 0;

        $new_count = 0;
        $accept_count = 0;
        $plan_count = 0;
        $schedule_count = 0;

        $query1 = "SELECT COUNT(*) count FROM pp_customer_orders
        WHERE date = CURDATE() AND create_from = 'USA'";
        $usa_today_count = DB::select($query1)[0];
        if ($usa_today_count) {
            $usa_today = $usa_today_count->count;
        }



        $query2 = 'SELECT COUNT(*) count FROM pp_customer_orders
        WHERE date LIKE "' . $date . '"  AND create_from = "USA"';
        $usa_month_count = DB::select($query2)[0];
        if ($usa_month_count) {
            $usa_month = $usa_month_count->count;
        }

        $query3 = "SELECT COUNT(*) count FROM pp_customer_orders
        WHERE date = CURDATE() AND create_from = 'SRI LANKA'";
        $local_today_count = DB::select($query3)[0];
        if ($local_today_count) {
            $local_today = $local_today_count->count;
        }


        $query4 = 'SELECT COUNT(*) count FROM pp_customer_orders
        WHERE date LIKE "' . $date . '"  AND create_from = "SRI LANKA"';
        $local_month_count = DB::select($query4)[0];
        if ($local_month_count) {
            $local_month = $local_month_count->count;
        }



        $query5 = 'SELECT COUNT(*) count FROM pp_customer_orders
        WHERE order_status = "0"';
        $new_status_count = DB::select($query5)[0];
        if ($new_status_count) {
            $new_count = $new_status_count->count;
        }


        $query6 = 'SELECT COUNT(*) count FROM pp_customer_orders
        WHERE (order_status = "1" OR order_status = "4") AND production_status = "0"';
        $accept_status_count = DB::select($query6)[0];
        if ($accept_status_count) {
            $accept_count = $accept_status_count->count;
        }


        $query7 = 'SELECT DISTINCT pp_customer_orders.order_id
        FROM pp_machinery_plans
        INNER JOIN st_products ON pp_machinery_plans.product_primary_id = st_products.product_primary_id 
        INNER JOIN pp_machinery ON pp_machinery_plans.machinery_id = pp_machinery.machinery_id
        LEFT JOIN pp_customer_order_plans_data ON pp_machinery_plans.customer_order_plan_data_id = pp_customer_order_plans_data.customer_order_plan_data_id
        LEFT JOIN pp_customer_order_plans ON pp_customer_order_plans_data.customer_order_plan_id = pp_customer_order_plans.customer_order_plan_id
        LEFT JOIN pp_customer_orders ON pp_customer_order_plans.order_id = pp_customer_orders.order_id WHERE MONTH(pp_machinery_plans.date) = MONTH(CURDATE()) 
        GROUP BY pp_machinery_plans.date,pp_machinery_plans.customer_order_plan_data_id,st_products.product_primary_id';
        $plan_count = count(DB::select($query7));


        $query8 = 'SELECT COUNT(`Data`.schedule_for_this_month) AS total_schedule_for_this_month   FROM 
        (SELECT  DISTINCT OH.order_id AS  schedule_for_this_month 
            FROM 
          pp_customer_orders  OH 
        INNER JOIN pp_customer_order_plans POH ON OH.order_id=POH.order_id
        INNER JOIN pp_customer_order_plans_data POD  ON  POH.customer_order_plan_id=POD.customer_order_plan_id
        INNER JOIN st_products P ON P.product_primary_id=POD.product_id 
        INNER JOIN st_customers C ON C.customer_id=OH.customer_id 
        
        INNER JOIN
        (SELECT DISTINCT customer_order_plan_data_id  FROM pd_schedule_machinery_plans 
        WHERE MONTH(`date`)=MONTH(CURDATE())  AND  YEAR(date)=YEAR(CURDATE())   ) PS ON POD.customer_order_plan_data_id=PS.customer_order_plan_data_id) Data';
        $schedule_count = DB::select($query8)[0]->total_schedule_for_this_month;


        return response()->json(
            [
                "usa_today" => $usa_today,
                "usa_month" => $usa_month,
                "local_today" => $local_today,
                "local_month" => $local_month,
                "new_status" => $new_count,
                "accept_status" => $accept_count,
                "plan_status" => $plan_count,
                "schedule_status" => $schedule_count
            ]
        );
    }





    public function tableProducedQuantity($date)
    {

        $query = 'SELECT  POD.customer_order_plan_data_id , OH.purchase_order As purchase_order , OH.factory_po_num , 
        C.customer_name , P.product_name , POD.quantity as ordered_quantity  , 
        IF(ISNULL(PRD.prodction_quantity), 0,PRD.prodction_quantity) AS producedQuantity   FROM 
          pp_customer_orders  OH 
        INNER JOIN pp_customer_order_plans POH ON OH.order_id=POH.order_id
        INNER JOIN pp_customer_order_plans_data POD  ON  POH.customer_order_plan_id=POD.customer_order_plan_id
        INNER JOIN st_products P ON P.product_primary_id=POD.product_id 
        INNER JOIN st_customers C ON C.customer_id=OH.customer_id 
        
        INNER JOIN
        (SELECT DISTINCT customer_order_plan_data_id  FROM pd_schedule_machinery_plans 
        WHERE `date`="'.$date.'") PS ON POD.customer_order_plan_data_id=PS.customer_order_plan_data_id
        LEFT JOIN 
        
        (SELECT customer_order_plan_data_id , SUM(quantity) AS prodction_quantity  FROM pd_production_records_supervisor 
        WHERE date="'.$date.'" 
        GROUP BY customer_order_plan_data_id ) PRD  ON PRD.customer_order_plan_data_id=POD.customer_order_plan_data_id';

        $result = DB::select($query);

        return response()->json(
            [
                "result" => $result
            ]
        );
    }




    public function tableScheduleOnGoing($date)
    {

        $query = 'SELECT  POD.customer_order_plan_data_id , OH.purchase_order As purchase_order , OH.factory_po_num , 
        C.customer_name , P.product_name , POD.quantity as ordered_quantity  , 
        IF(ISNULL(PRD.prodction_quantity), 0,PRD.prodction_quantity) AS producedQuantity,
        IF(ISNULL(PRD.today_quantity), 0,PRD.today_quantity) AS todayQuantity FROM 
          pp_customer_orders  OH 
        INNER JOIN pp_customer_order_plans POH ON OH.order_id=POH.order_id
        INNER JOIN pp_customer_order_plans_data POD  ON  POH.customer_order_plan_id=POD.customer_order_plan_id
        INNER JOIN st_products P ON P.product_primary_id=POD.product_id 
        INNER JOIN st_customers C ON C.customer_id=OH.customer_id 
        
        INNER JOIN
        (SELECT DISTINCT customer_order_plan_data_id  FROM pd_schedule_machinery_plans 
        WHERE `date`="'.$date.'") PS ON POD.customer_order_plan_data_id=PS.customer_order_plan_data_id
        LEFT JOIN 
        
        (SELECT customer_order_plan_data_id , SUM(quantity) AS prodction_quantity, SUM(IF(CURDATE() = "'.$date.'",quantity,0)) AS today_quantity  FROM pd_production_records_supervisor 
        WHERE date="'.$date.'"
        GROUP BY customer_order_plan_data_id ) PRD  ON PRD.customer_order_plan_data_id=POD.customer_order_plan_data_id
        
        WHERE POD.production_status=3';

        $result = DB::select($query);

        return response()->json(
            [
                "result" => $result
            ]
        );
    }
}
